DEFINE_ENCODING 'UTF-8'
{entete_10_0.m}
{
File: KE Tools.m
Version: 10_0
Date: 10th August 2024
Author: Gerard Leclercq
E-mail: kotom.eng@free.fr
Web site : http://kotom.eng.free.fr

Copyright 2021-2024 Gerard Leclercq

{ ============================== ENGLISH =============================== }
{ This file is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.  If not, see http://www.gnu.org/licenses. }

{ ============================== FRANCAIS ============================== }
{ Le contenu de ce fichier libre. Vous pouvez le redistribuer et/ou le modifier suivant les conditions de la licence publique générale GNU publiée par la Free Software Foundation, soit à la version 3 de la licence, ou, à votre convenance, à n'importe quelle version ultérieure.

Le contenu de ce fichier est distribué dans la pensée qu'il peut être utile, mais SANS AUCUNE GARANTIE, sans même la garantie implicite de QUALITÉ MARCHANDE ou d'ADÉQUATION À UN USAGE PARTICULIER. Voir les conditions de la licence publique générale GNU pour plus de détails.

Vous devriez avoir une copie de la licence publique générale GNU dans ce fichier zip. Sinon, voir http://www.gnu.org/licenses. }


{ ============================== ENGLISH =============================== }
{ Write here the installation directory of the Kotom-Eng Tools for example:
LET KE_install_dir 'C:\Users\my_login_name'
}
{ ============================== FRANCAIS ============================== }
{ Ecrivez ici le répertoire d'installation de Kotom-Eng Tools par exemple :
LET KE_install_dir 'C:\Users\mon_nom_de_login'
}

LET KE_install_dir 'C:\Users\Asterix'


{ ============================== ENGLISH =============================== }
{ To keep the dimension standard (ANSI, ISO, DIN, JIS ou COMPANY) at each starting of Drafting, change 0 by 1 in the following line. }
{ ============================== FRANCAIS ============================== }
{ Pour conserver le standard de cotation (ANSI, ISO, DIN, JIS ou USINE) à chaque démarrage de Drafting, changer 0 en 1 dans la ligne suivante. }

LET KE_dim_std_enable 0

{ ====================================================================== }

BINDTEXTDOMAIN 'KE' (KE_install_dir+'\locale')
BINDTEXTDOMAIN 'KEm' (KE_install_dir+'\locale')

LET KE_dir_temp ( GETENV 'TEMP' )
LET KE_dir_home (( GETENV 'HOMEDRIVE' ) + ( GETENV 'HOMEPATH' ))

LET KE_calc_file (KE_dir_temp+'\KE_calc_macro.m')
LET KE_calc_tab_name     'KE_calc'
LET KE_calc_tab_name_all 'KE_calc_all'
LET KE_calc_col_name    1
LET KE_calc_col_formula 2
LET KE_calc_col_dep_pos 3
LET KE_calc_col_value   4
LET KE_calc_col_round   5
LET KE_calc_col_dep     6
LET KE_calc_round_default '1'
LET KE_calc_show_bg_color 0.6,0.6,0.6

LET KE_cse_file_in_tmp  (KE_dir_temp+'\KE_cse_file_in_tmp.mi')
LET KE_cse_file_log_tmp (KE_dir_temp+'\KE_cse_file_log.txt')
LET KE_cse_file_out_tmp (KE_dir_temp+'\KE_cse_file_out_tmp.mi')

LET KE_dim_std_file_mod (KE_dir_home + '\KE_da_std.m')
LET KE_dim_std_file_save 'KE_dim_std.m'

LET KE_lib_file_exists_tmp_file (KE_dir_temp + '\KE_lib_file_exists_tmp_file.m')

LET KE_n_no 0
LET KE_n_yes 1

LET KE_txt_colour_shade     0.6,0.6,0.6
LET KE_txt_colour_highlight 1,0,0

LET KE_txt_csv_to_txt_int_lin 5
LET KE_txt_csv_to_txt_int_col 50

LET KE_txt_on_line_offset   1

LET KE_txt_txt_to_csv_round 1

{ librairie_10_0.m }
{ ============================= LIBRARIES ============================== }

DEFINE KE_lib_file_csv_to_csl

{ ============================== ENGLISH =============================== }
{ The special characters " and ; in the csv file are escaped as follow:
Displayed in Drafting  Written in csv
=====================  ==============  
ABC D"E GHI            ABC;"D""E";GHI
ABC D;E GHI            ABC;"D;E"
ABC D;" GHI            ABC;"D;""";GHI}

{ ============================== FRANCAIS ============================== }
{ Les caractères spéciaux " et ; dans le fichier csv sont échapés de la façon suivante :
Affiché dans Drafting  Ecrit dans le csv
=====================  =================  
ABC D"E GHI            ABC;"D""E";GHI
ABC D;E GHI            ABC;"D;E"
ABC D;" GHI            ABC;"D;""";GHI}

  PARAMETER Name_csv
  PARAMETER Name_csl

  LOCAL Char
  LOCAL Ctr
  LOCAL Line_csl
  LOCAL Line_csv
  LOCAL Line_len

  OPEN_INFILE 1 ENCODING "UTF-8" Name_csv
  OPEN_OUTFILE 2 ENCODING "UTF-8" DEL_OLD Name_csl
  WRITE_FILE 2 "%T,,,"
  WRITE_FILE 2 "%N,,,"

  LOOP
    READ_FILE 1 Line_csv
  EXIT_IF (Line_csv = 'END-OF-FILE')
    LET Line_len ( LEN Line_csv )
    LET Ctr 1
    LET Line_csl ''
    WHILE (Ctr <= Line_len)
      LET Char ( SUBSTR Line_csv Ctr 1)
      IF (Char = '"') { Cell beginning with a '"'. }
        LET Line_csl (Line_csl+'"')
        LET Ctr (Ctr+1)
        LOOP
        EXIT_IF ((Ctr >= Line_len) OR (( SUBSTR Line_csv Ctr 2) = '";'))
          LET Char ( SUBSTR Line_csv Ctr 1)
          LET Line_csl (Line_csl+Char)
          LET Ctr (Ctr+1)
        END_LOOP
        LET Line_csl (Line_csl+'"')
        LET Ctr (Ctr+1)
      ELSE_IF (Char = ';')
        IF (Ctr = 1)
          LET Line_csl (Line_csl+'"",')
          LET Ctr (Ctr+1)
        ELSE
          LET Line_csl (Line_csl+',')
          LET Ctr (Ctr+1)
        END_IF
      ELSE { Cell without special characters. }{ Cellule sans caractère spécial. }
        LET Line_csl (Line_csl+'"')
        LOOP
          LET Char ( SUBSTR Line_csv Ctr 1)
        EXIT_IF ((Ctr > Line_len) OR (Char = ';'))
          LET Line_csl (Line_csl+Char)
          LET Ctr (Ctr+1)
        END_LOOP
        LET Line_csl (Line_csl+'"')
      END_IF
    END_WHILE
    WRITE_FILE 2 Line_csl
  END_LOOP

  CLOSE_FILE 1
  CLOSE_FILE 2

END_DEFINE


DEFINE KE_lib_file_csv_to_ltab
  PARAMETER Name_csv
  PARAMETER Name_ltab

  LOCAL File_csl
  LOCAL Result

  IF (Name_csv = '')
    INQ_ENV 10
    IF ( INQ 19 )
      LET Result ( WUI_FILE_DIALOG SET_DIR FILTER 'csv|*.csv|*.*|*.*||')
      IF (Result = 'OK')
        INQ_ENV 0
        LET Name_csv ( INQ 904 )
      ELSE
        CANCEL
      END_IF
    ELSE
      Fbt_dtabs_all_on 0
      READ STRING PROMPT ( DGETTEXT 'KE' "Enter the 'Name' of the csv file" ) Name_csv
    END_IF
  END_IF
  KE_lib_str_left Name_csv 4
  LET File_csl (KE_lib_str_left_r+'.csl')
  KE_lib_file_csv_to_csl Name_csv File_csl
  CSL_TO_LTAB Name_ltab File_csl
END_DEFINE


{ ============================== ENGLISH =============================== }
{ Determine if the file File exists in the directory Dir.
  Result KE_lib_file_exists_r = KE_n_yes or KE_n_no }
{ ============================== FRANCAIS ============================== }
{ Détérmine si le fichier File existe dans le répertoire Dir.
  Résultat KE_lib_file_exists_r = KE_n_yes or KE_n_no }

DEFINE KE_lib_file_exists
  PARAMETER Dir
  PARAMETER File

  LOCAL Lin

  CATALOG_LAYOUT (64 * ' ') END
  DEFINE_CATALOG 'File name' 'FILE_NAME' 1 1
  CATALOG Dir SELECT 'FILE_NAME' = File DEL_OLD KE_lib_file_exists_tmp_file
  LET KE_lib_file_exists_r KE_n_no

  OPEN_INFILE 10 KE_lib_file_exists_tmp_file
  READ_FILE 10 Lin { DIRECTORY : }
  READ_FILE 10 Lin { EMPTY }
  READ_FILE 10 Lin { Nom fich. }
  READ_FILE 10 Lin { ================= }
  READ_FILE 10 Lin { File }
  CLOSE_FILE 10
  IF (Lin = File)
    LET KE_lib_file_exists_r KE_n_yes
  END_IF
END_DEFINE


DEFINE KE_lib_file_ltab_to_csv
  PARAMETER Ltab_name
  PARAMETER File_csv

  LOCAL Col
  LOCAL Lin
  LOCAL Nb_col
  LOCAL Nb_line
  LOCAL Text

  LET Nb_line ( LTAB_ROWS Ltab_name )
  LET Nb_col ( LTAB_COLUMNS Ltab_name )

  LET Lin 1
  OPEN_OUTFILE 1 ENCODING "UTF-8" DEL_OLD File_csv
  WHILE (Lin <= Nb_line)
    LET Col 1
    LET Text ''
    WHILE (Col <= Nb_col)
      KE_lib_str_replace_char ( STR ( READ_LTAB Ltab_name Lin Col )) '"' '""'
      LET Text (Text + '"' + KE_lib_str_replace_char_r + '"')
      LET Col (Col+1)
      IF (Col <= Nb_col)
        LET Text (Text + ';')
      END_IF
    END_WHILE
    WRITE_FILE 1 Text
    LET Lin (Lin+1)
  END_WHILE
  CLOSE_FILE 1
END_DEFINE


DEFINE KE_lib_str_left
  PARAMETER Strg
  PARAMETER Nbr
  
  LET KE_lib_str_left_r ( SUBSTR Strg 1 (( LEN Strg ) - Nbr) )

END_DEFINE


{ ============================== ENGLISH =============================== }
{ Retreive the string being on the left of the first character Char found in the string Strg.
If Char is not in Strg, the result is Strg. }
{ ============================== FRANCAIS ============================== }
{ Donne la chaîne se trouvant à gauche du premier caractère Char trouvé dans la
chaîne Strg. Si Char n'est pas dans Strg, le résultat est Strg.}

DEFINE KE_lib_str_left_of
  PARAMETER Strg
  PARAMETER Char
  
  LOCAL Pos

  LET Pos ( POS Strg Char )
  IF (Pos<1) LET KE_lib_str_left_of_r Strg
  ELSE       LET KE_lib_str_left_of_r ( SUBSTR Strg 1 (Pos - 1) )
  END_IF
END_DEFINE


DEFINE KE_lib_str_replace_char
{ ============================== ENGLISH =============================== }
{ Replace all the occurrences of a character Char in a string Str_main by another string Str_rep. }
{ ============================== FRANCAIS ============================== }
{ Remplace toutes les occurences du caractère Char dans une chaîne Str_main par une autre chaîne Str_rep.}
  
  PARAMETER Str_main
  PARAMETER Char_rep
  PARAMETER Str_rep
  
  LOCAL Char
  LOCAL Ctr
  LOCAL Length

  LET KE_lib_str_replace_char_r ''
  LET Length ( LEN Str_main )
  LET Ctr 1
  WHILE (Ctr<=Length)
    LET Char ( SUBSTR Str_main Ctr 1 )
    IF (Char=Char_rep)
      LET KE_lib_str_replace_char_r (KE_lib_str_replace_char_r+Str_rep)
    ELSE
      LET KE_lib_str_replace_char_r (KE_lib_str_replace_char_r+Char)
    END_IF
    LET Ctr (Ctr+1)
  END_WHILE
END_DEFINE


{ ============================== ENGLISH =============================== }
{ Retreive the string being on the right of the first character Char found in the string Strg.
If Char is not in Strg, the result is Strg. }
{ ============================== FRANCAIS ============================== }
{ Donne la chaîne se trouvant à droite du premier caractère Char trouvé dans la
chaîne Strg. Si Char n'est pas dans Strg, le résultat est Strg. }

DEFINE KE_lib_str_right_of
  PARAMETER Strg
  PARAMETER Char
  
  LOCAL Pos

  LET Pos ( POS Strg Char )
  IF (Pos<1) LET KE_lib_str_right_of_r Strg
  ELSE       LET KE_lib_str_right_of_r ( SUBSTR Strg (Pos + 1) ( LEN Strg ) )
  END_IF
END_DEFINE

{ ======================= REDEFINED ME10 MACROS ======================== }

DEFINE KE_me10_table_control_icons

  PARAMETER Table_name

  LOCAL Fix_flag

  INQ_TABLE Table_name
  LET Fix_flag ( INQ 4 )
  TABLE_TITLE Table_name
  IF (Fix_flag=0)
    BLACK YELLOW Menu_unfix_icon ("Table_fix_unfix '"+Table_name+"'") 1 1
  ELSE
    BLACK YELLOW Menu_fix_icon ("Table_fix_unfix '"+Table_name+"'") 1 1
  END_IF
  BLACK YELLOW Menu_move_icon (" TABLE_STATUS '"+Table_name+"' MOVE ") 1 2
  BLACK YELLOW Menu_delete_icon (" TABLE_STATUS '"+Table_name+"' UNMAP ") 1 4
  END
END_DEFINE

{ tables_9_1.m }
{ =============================== TABLE =============================== }

CREATE_LTAB 10 10 KE_calc_tab_name

LET KE_tmp ( RPT ' ' 10 + '|' + RPT ' ' 30 + '|' + RPT ' ' 10)

TABLE_LAYOUT KE_calc_tab_name KE_calc_tab_name
  WHITE BLACK
  ROWS 10
  FRAME_WIDTH 2
  HORIZONTAL BLACK SOLID
  VERTICAL BLACK SOLID
  SCROLL_BAR WHITE BLUE 20
TITLE_LAYOUT ('  |  |'+ RPT ' ' ( LEN KE_tmp ) + '| ') KE_tmp END
COLUMN_LAYOUT KE_tmp END

KE_me10_table_control_icons KE_calc_tab_name
TABLE_TITLE KE_calc_tab_name BLACK YELLOW ( DGETTEXT 'KE' "CALCULATION" ) 1 3 END
TABLE_TITLE KE_calc_tab_name WHITE BLUE ( DGETTEXT 'KE' "NAME" ) 2 1 END
TABLE_TITLE KE_calc_tab_name WHITE BLUE ( DGETTEXT 'KE' "VALUE/FORMULA" ) 2 2 END
TABLE_TITLE KE_calc_tab_name WHITE BLUE ( DGETTEXT 'KE' "ROUNDING" ) 2 3 END

TABLE_COLUMN KE_calc_tab_name COLUMN 1  GREEN BLACK KE_calc_col_name     LEFT ('@q'+ STR KE_calc_col_name)  END
TABLE_COLUMN KE_calc_tab_name COLUMN 2  GREEN BLACK KE_calc_col_formula  LEFT ('@q'+ STR KE_calc_col_formula)  END
TABLE_COLUMN KE_calc_tab_name COLUMN 3  GREEN BLACK KE_calc_col_round    LEFT ('@q'+ STR KE_calc_col_round)  END


{ =============================== TABLE =============================== }

LET KE_tmp ( RPT ' ' 10 + '|' + RPT ' ' 30 + RPT ('|' + RPT ' ' 10) 8)

TABLE_LAYOUT KE_calc_tab_name_all KE_calc_tab_name
  WHITE BLACK
  ROWS 10
  FRAME_WIDTH 2
  HORIZONTAL BLACK SOLID
  VERTICAL BLACK SOLID
  SCROLL_BAR WHITE BLUE 20
TITLE_LAYOUT ('  |  |'+ RPT ' ' ( LEN KE_tmp ) + '| ') KE_tmp END
COLUMN_LAYOUT KE_tmp END

KE_me10_table_control_icons KE_calc_tab_name_all
TABLE_TITLE KE_calc_tab_name_all BLACK YELLOW ( DGETTEXT 'KE' "CALCULATION" ) 1 3 END
TABLE_TITLE KE_calc_tab_name_all WHITE BLUE ( DGETTEXT 'KE' "NAME" ) 2 1 END
TABLE_TITLE KE_calc_tab_name_all WHITE BLUE ( DGETTEXT 'KE' "VALUE/FORMULA" ) 2 2 END
TABLE_TITLE KE_calc_tab_name_all WHITE BLUE ( DGETTEXT 'KE' "POSITION" ) 2 3 END
TABLE_TITLE KE_calc_tab_name_all WHITE BLUE ( DGETTEXT 'KE' "VALUE" ) 2 4 END
TABLE_TITLE KE_calc_tab_name_all WHITE BLUE ( DGETTEXT 'KE' "ROUNDING" ) 2 5 END
TABLE_TITLE KE_calc_tab_name_all WHITE BLUE ( DGETTEXT 'KE' "DEP" ) 2 6 END
TABLE_TITLE KE_calc_tab_name_all WHITE BLUE ( DGETTEXT 'KE' "DEP" ) 2 7 END
TABLE_TITLE KE_calc_tab_name_all WHITE BLUE ( DGETTEXT 'KE' "DEP" ) 2 8 END
TABLE_TITLE KE_calc_tab_name_all WHITE BLUE ( DGETTEXT 'KE' "DEP" ) 2 9 END
TABLE_TITLE KE_calc_tab_name_all WHITE BLUE ( DGETTEXT 'KE' "DEP" ) 2 10 END

TABLE_COLUMN KE_calc_tab_name_all COLUMN 1  GREEN BLACK KE_calc_col_name     LEFT ('@q'+ STR KE_calc_col_name)  END
TABLE_COLUMN KE_calc_tab_name_all COLUMN 2  GREEN BLACK KE_calc_col_formula  LEFT ('@q'+ STR KE_calc_col_formula)  END
TABLE_COLUMN KE_calc_tab_name_all COLUMN 3  GREEN BLACK KE_calc_col_dep_pos    LEFT ('@q'+ STR KE_calc_col_dep_pos)  END
TABLE_COLUMN KE_calc_tab_name_all COLUMN 4  GREEN BLACK KE_calc_col_value    LEFT ('@q'+ STR KE_calc_col_value)  END
TABLE_COLUMN KE_calc_tab_name_all COLUMN 5  GREEN BLACK KE_calc_col_round    LEFT ('@q'+ STR KE_calc_col_round)  END
TABLE_COLUMN KE_calc_tab_name_all COLUMN 6  GREEN BLACK KE_calc_col_dep    LEFT ('@q'+ STR KE_calc_col_dep)  END
TABLE_COLUMN KE_calc_tab_name_all COLUMN 7  GREEN BLACK 7  LEFT '@q7'  END
TABLE_COLUMN KE_calc_tab_name_all COLUMN 8  GREEN BLACK 8  LEFT '@q8'  END
TABLE_COLUMN KE_calc_tab_name_all COLUMN 9  GREEN BLACK 9  LEFT '@q9'  END
TABLE_COLUMN KE_calc_tab_name_all COLUMN 10  GREEN BLACK 10 LEFT '@q10' END


{ calc_9_1.m }
{ ====================================================================== }


DEFINE KE_calc_check_for_name
  LOCAL Flag
  LOCAL Lin
  LOCAL Nb_row
  
  HIGHLIGHT_LTAB KE_calc_tab_name ALL OFF
  LET Nb_row ( LTAB_ROWS KE_calc_tab_name )
  LET Flag 0
  LET Lin 1
  WHILE (Lin <= Nb_row)
    IF (( READ_LTAB KE_calc_tab_name Lin KE_calc_col_name ) = '')
      HIGHLIGHT_LTAB KE_calc_tab_name ROW Lin ON
      LET Flag 1
    END_IF
    LET Lin (Lin+1)
  END_WHILE
  IF (Flag)
    SHOW_TABLE ON KE_calc_tab_name
    DISPLAY ( DGETTEXT 'KE' "A Name is mandatory" )
    CANCEL
  END_IF
END_DEFINE

DEFINE KE_calc_clear_name
  LOCAL P00

  KE_calc_show
  LOOP
    READ PNT PROMPT ( DGETTEXT 'KE' "Identify text for clearing Name and formula" ) P00
    CHANGE_ELEM_INFO 'KE_CALC_*' '' GLOBAL P00
    KE_calc_show
  END_LOOP
END_DEFINE


DEFINE KE_calc_dep_set_pos
  LOCAL Col
  LOCAL Dep
  LOCAL Dep_lin
  LOCAL Dep_pos
  LOCAL Dep_pos_max
  LOCAL Found_pos
  LOCAL Lin

  LOOP
  EXIT_IF (KE_calc_nb_formula = 0)
    LET Lin 1
    LET Found_pos 0
    WHILE (Lin <= KE_calc_nb_formula)
      LET Col KE_calc_col_dep
      LET Dep_pos_max 0
      LOOP
        LET Dep ( READ_LTAB KE_calc_tab_name Lin Col )
      EXIT_IF (Dep = '')
        SELECT_FROM_LTAB KE_calc_tab_name COLUMN KE_calc_col_name = Dep END
        LET Dep_lin ( READ_LTAB  'sys_select' 1 1 )
        IF (Dep_lin = '')
          DISPLAY ( DGETTEXT 'KE' "Error: a variable depends on an undefined variable")
          CANCEL
        END_IF
        LET Dep_pos ( READ_LTAB KE_calc_tab_name Dep_lin KE_calc_col_dep_pos )
        IF (Dep_pos = '')
          WRITE_LTAB KE_calc_tab_name Lin KE_calc_col_dep_pos ''
        ELSE
          IF (Dep_pos > Dep_pos_max)
            LET Dep_pos_max Dep_pos
          END_IF
          WRITE_LTAB KE_calc_tab_name Lin KE_calc_col_dep_pos (Dep_pos_max+1)
          LET Col (Col+1)
        END_IF
      EXIT_IF (Dep_pos = '')
      END_LOOP
      IF (( READ_LTAB KE_calc_tab_name Lin KE_calc_col_dep_pos ) <> '' )
        LET Found_pos (Found_pos+1)
      END_IF
      LET Lin (Lin+1)
    END_WHILE
    LET KE_calc_nb_formula (KE_calc_nb_formula - Found_pos)
    SORT_LTAB KE_calc_tab_name KE_calc_col_dep_pos CONFIRM
    IF (Found_pos = 0)
      DISPLAY ( DGETTEXT 'KE' "Error: two variables are dependant of each other")
      CANCEL
    END_IF
  END_LOOP
END_DEFINE


DEFINE KE_calc_dep_set_pos_input_data
  LOCAL Lin
  LOCAL Nb_row
  
  LET Nb_row ( LTAB_ROWS KE_calc_tab_name )
  LET Lin 1
  LET KE_calc_nb_formula Nb_row
  WHILE (Lin <= Nb_row)
    IF (( READ_LTAB KE_calc_tab_name Lin KE_calc_col_dep ) = '')
      WRITE_LTAB KE_calc_tab_name Lin KE_calc_col_dep_pos 0
      LET KE_calc_nb_formula (KE_calc_nb_formula-1)
    END_IF
    LET Lin (Lin+1)
  END_WHILE
  
  SORT_LTAB KE_calc_tab_name KE_calc_col_dep_pos CONFIRM
END_DEFINE


DEFINE KE_calc_do_calc
  SHOW GLOBAL ALL ON
  KE_calc_fill_table
  KE_calc_check_for_name
  KE_calc_parse
  KE_calc_dep_set_pos_input_data
  KE_calc_dep_set_pos
  KE_calc_write_file
  INPUT KE_calc_file
END_DEFINE


DEFINE KE_calc_fill_table
  LOCAL Lin
  LOCAL Nb_elt
  LOCAL Nb_row
  LOCAL Text_info
  
  CREATE_LTAB 10 10 KE_calc_tab_name
  INQ_SELECTED_ELEM GLOBAL INFOS 'KE_CALC_*'
  LET Nb_elt ( INQ 14 )

  LET Lin 1
  WHILE (Lin<=Nb_elt)
    LET Text_info ( INQ 900 )
    KE_calc_fill_table_get_info
    LOOP
      LET Text_info ( INQ 901 )
    EXIT_IF (Text_info = 'END-OF-LIST')
      KE_calc_fill_table_get_info
    END_LOOP
    IF (( READ_LTAB KE_calc_tab_name Lin KE_calc_col_formula ) = '')
      WRITE_LTAB KE_calc_tab_name Lin KE_calc_col_formula ( INQ 902 )
    END_IF
    INQ_NEXT_ELEM
    LET Lin (Lin+1)
  END_WHILE

  LET Nb_row ( LTAB_ROWS KE_calc_tab_name )
  LET Lin 1
  WHILE (Lin<=Nb_elt)
    IF (( READ_LTAB KE_calc_tab_name Lin KE_calc_col_round ) = '')
      WRITE_LTAB KE_calc_tab_name Lin KE_calc_col_round ( KE_calc_round_default )
    END_IF
    LET Lin (Lin+1)
  END_WHILE
END_DEFINE


DEFINE KE_calc_fill_table_get_info
  KE_lib_str_left_of Text_info ':'
  KE_lib_str_right_of Text_info ':'
  IF (KE_lib_str_left_of_r = 'KE_CALC_NAME')
    WRITE_LTAB KE_calc_tab_name Lin KE_calc_col_name KE_lib_str_right_of_r
  ELSE_IF (KE_lib_str_left_of_r = 'KE_CALC_FORMULA')
    WRITE_LTAB KE_calc_tab_name Lin KE_calc_col_formula KE_lib_str_right_of_r
  ELSE_IF (KE_lib_str_left_of_r = 'KE_CALC_ROUNDING')
    WRITE_LTAB KE_calc_tab_name Lin KE_calc_col_round KE_lib_str_right_of_r
  END_IF
END_DEFINE


DEFINE KE_calc_get_info
  PARAMETER Info
  PARAMETER P00

  LOCAL Text_info

  LET KE_calc_get_info_r 'NOT-A-TEXT'
  INQ_SELECTED_ELEM GLOBAL P00
  IF (( INQ 403 ) = TEXT )
    LET KE_calc_get_info_r ''
    LET Text_info ( INQ 900 )
    KE_lib_str_left_of Text_info ':'
    IF (KE_lib_str_left_of_r = Info)
      KE_lib_str_right_of Text_info ':'
      LET KE_calc_get_info_r KE_lib_str_right_of_r
    ELSE
      LOOP
        LET Text_info ( INQ 901 )
      EXIT_IF (Text_info = 'END-OF-LIST')
        KE_lib_str_left_of Text_info ':'
        IF (KE_lib_str_left_of_r = Info)
          KE_lib_str_right_of Text_info ':'
          LET KE_calc_get_info_r KE_lib_str_right_of_r
        END_IF
      END_LOOP
    END_IF
  END_IF
END_DEFINE


DEFINE KE_calc_name_proper_do
  PARAMETER Name
  
  LOCAL Ctr
  LOCAL Length
  
  LET Char ( UPC ( SUBSTR Name 1 1 ) )
  IF (((Char >= 'A') AND (Char <= 'Z')) OR ((Char >= '0') AND (Char <= '9')) OR (Char = '_'))
    LET KE_calc_name_proper Char
  ELSE
    LET KE_calc_name_proper 'A'
  END_IF
  LET Length ( LEN Name )
  LET Ctr 2
  WHILE (Ctr <= Length)
    LET Char ( LWC ( SUBSTR Name Ctr 1 ) )
    IF (((Char >= 'a') AND (Char <= 'z')) OR ((Char >= '0') AND (Char <= '9')) OR (Char = '_'))
      LET KE_calc_name_proper (KE_calc_name_proper + Char)
    END_IF
    LET Ctr (Ctr+1)
  END_WHILE
END_DEFINE


DEFINE KE_calc_parse
  LOCAL Char
  LOCAL Col
  LOCAL Ctr
  LOCAL Lin
  LOCAL Flag
  LOCAL Formula
  LOCAL Lgth
  LOCAL Nb_row
  LOCAL Var

  LET Nb_row ( LTAB_ROWS KE_calc_tab_name )
  LET Lin 1
  WHILE (Lin <= Nb_row)
    LET Formula ( READ_LTAB KE_calc_tab_name Lin KE_calc_col_formula )
    LET Lgth ( LEN Formula )
    LET Var ''
    LET Flag 'NOT_IN_VAR'
    LET Ctr 1
    LET Col KE_calc_col_dep
    WHILE (Ctr <= Lgth)
      LET Char ( SUBSTR Formula Ctr 1 )
      IF (Flag = 'NOT_IN_VAR')
        IF ((( UPC Char ) >= 'A') AND (( UPC Char ) <= 'Z'))
          LET Var Char
          LET Flag 'IN_VAR'
          IF (Ctr = Lgth)
            IF ( TYPE VAL Var = MACRO )
              KE_calc_name_proper_do Var
              WRITE_LTAB KE_calc_tab_name Lin Col KE_calc_name_proper
            END_IF
          END_IF
        END_IF
      ELSE
        IF (((( UPC Char ) >= 'A') AND (( UPC Char ) <= 'Z')) OR ((Char >= '0') AND (Char <= '9')) OR (Char = '_'))
          LET Var (Var+Char)
          IF (Ctr = Lgth)
            IF ( TYPE VAL Var = MACRO )
              KE_calc_name_proper_do Var
              WRITE_LTAB KE_calc_tab_name Lin Col KE_calc_name_proper
            END_IF
          END_IF
        ELSE
          LET Flag 'NOT_IN_VAR'
          IF ( TYPE VAL Var = MACRO )
              KE_calc_name_proper_do Var
            WRITE_LTAB KE_calc_tab_name Lin Col KE_calc_name_proper
            LET Col (Col+1)
          END_IF
        END_IF
      END_IF
      LET Ctr (Ctr+1)
    END_WHILE
    LET Lin (Lin+1)
  END_WHILE
END_DEFINE


DEFINE KE_calc_set_formula
  LOCAL Exit_loop
  LOCAL Formula
  LOCAL P00

  HIGHLIGHT_LTAB KE_calc_tab_name ALL OFF
  LOOP
    KE_calc_show
    LOOP
      READ PNT PROMPT ( DGETTEXT 'KE' "Identify text for setting formula" ) P00
      KE_calc_get_info 'KE_CALC_NAME' P00
      IF (KE_calc_get_info_r = '')
        DISPLAY ( DGETTEXT 'KE' "This text has no Name. Set Name before entering a formula" )
      END_IF
    EXIT_IF ((KE_calc_get_info_r <> '') AND (KE_calc_get_info_r <> 'NOT-A-TEXT'))
    END_LOOP
    KE_calc_get_info 'KE_CALC_FORMULA' P00
    KE_calc_show
    SHOW GLOBAL P00 GREEN
    
    LET Exit_loop 0
    LOOP
      READ STRING PNT PROMPT ( DGETTEXT 'KE' "Enter the 'formula' or identify new text" ) DEFAULT KE_calc_get_info_r Formula
      IF (( TYPE Formula ) = PNT )
        LET P00 Formula
        KE_calc_get_info 'KE_CALC_NAME' P00
        IF (KE_calc_get_info_r = 'NOT-A-TEXT')
          LET Exit_loop 1
        ELSE_IF (KE_calc_get_info_r = '')
          DISPLAY ( DGETTEXT 'KE' "This text has no Name. Set Name before entering a formula" )
          LET Exit_loop 1
        ELSE
          KE_calc_get_info 'KE_CALC_FORMULA' P00
          KE_calc_show
          SHOW GLOBAL P00 GREEN
        END_IF
      ELSE
        CHANGE_ELEM_INFO 'KE_CALC_FORMULA:*' '' GLOBAL P00
        ADD_ELEM_INFO ('KE_CALC_FORMULA:'+Formula) GLOBAL P00
        LET KE_calc_get_info_r ''
      END_IF
    EXIT_IF (Exit_loop)
    END_LOOP
  END_LOOP
END_DEFINE


DEFINE KE_calc_set_name
  LOCAL Name
  LOCAL P00

  HIGHLIGHT_LTAB KE_calc_tab_name ALL OFF
  LOOP
    KE_calc_show
    LOOP
      READ PNT PROMPT ( DGETTEXT 'KE' "Identify text for setting Name" ) P00
      KE_calc_get_info 'KE_CALC_NAME' P00
    EXIT_IF (KE_calc_get_info_r <> 'NOT-A-TEXT')
    END_LOOP
    KE_calc_show
    SHOW GLOBAL P00 GREEN
    
   LET Exit_loop 0
   LOOP
      READ STRING PNT PROMPT ( DGETTEXT 'KE' "Enter the 'Name' (first letter Uppercase, other lowercase, eg 'Dia_cyl3') or identify new text" ) DEFAULT KE_calc_get_info_r Name
      IF (( TYPE Name ) = PNT )
        LET P00 Name
        KE_calc_get_info 'KE_CALC_NAME' P00
        IF (KE_calc_get_info_r = 'NOT-A-TEXT')
          LET Exit_loop 1
        ELSE
          KE_calc_get_info 'KE_CALC_NAME' P00
          KE_calc_show
          SHOW GLOBAL P00 GREEN
        END_IF
      ELSE
        KE_calc_name_proper_do Name
        CHANGE_ELEM_INFO 'KE_CALC_NAME:*' '' GLOBAL P00
        ADD_ELEM_INFO ('KE_CALC_NAME:'+KE_calc_name_proper) GLOBAL P00
        LET KE_calc_get_info_r ''
      END_IF
    EXIT_IF (Exit_loop)
    END_LOOP
  END_LOOP
END_DEFINE


DEFINE KE_calc_set_rounding
  LOCAL Exit_loop
  LOCAL Rounding
  LOCAL P00

  HIGHLIGHT_LTAB KE_calc_tab_name ALL OFF
  LOOP
    KE_calc_show
    LOOP
      READ PNT PROMPT ( DGETTEXT 'KE' "Identify text for setting the number of decimal places" ) P00
      KE_calc_get_info 'KE_CALC_ROUNDING' P00
    EXIT_IF (KE_calc_get_info_r <> 'NOT-A-TEXT')
    END_LOOP
    KE_calc_show
    SHOW GLOBAL P00 GREEN
    
   LET Exit_loop 0
   LOOP
      IF (KE_calc_get_info_r = '')
        LET KE_calc_get_info_r KE_calc_round_default
      ELSE
        LET KE_calc_get_info_r ( VAL KE_calc_get_info_r )
      END_IF
      READ NUMBER PNT PROMPT ( DGETTEXT 'KE' "Enter the number of decimal places or identify new text" ) DEFAULT KE_calc_get_info_r Rounding
      IF (( TYPE Rounding ) = PNT )
        LET P00 Rounding
        KE_calc_get_info 'KE_CALC_ROUNDING' P00
        IF (KE_calc_get_info_r = 'NOT-A-TEXT')
          LET Exit_loop 1
        ELSE
          KE_calc_get_info 'KE_CALC_ROUNDING' P00
          KE_calc_show
          SHOW GLOBAL P00 GREEN
        END_IF
      ELSE
        CHANGE_ELEM_INFO 'KE_CALC_ROUNDING:*' '' GLOBAL P00
        ADD_ELEM_INFO ('KE_CALC_ROUNDING:'+ STR Rounding) GLOBAL P00
        LET KE_calc_get_info_r ''
      END_IF
    EXIT_IF (Exit_loop)
    END_LOOP
  END_LOOP
END_DEFINE


DEFINE KE_calc_show
  SPOTLIGHT OFF
  SHOW GLOBAL ALL RGB_COLOR KE_calc_show_bg_color
  SHOW GLOBAL INFOS 'KE_CALC_*' YELLOW
  
END_DEFINE


DEFINE KE_calc_update_text
  LOCAL Lin
  LOCAL Nb_elt
  LOCAL Text_info

  INQ_SELECTED_ELEM GLOBAL INFOS 'KE_CALC_FORMULA:*'
  LET Nb_elt ( INQ 14 )
  LET Lin 1
  WHILE (Lin <= Nb_elt)
    LET Text_info ( INQ 900 )
    KE_calc_update_text_get_info
    LOOP
      LET Text_info ( INQ 901 )
    EXIT_IF (Text_info = 'END-OF-LIST')
      KE_calc_update_text_get_info
    END_LOOP
    INQ_NEXT_ELEM
    LET Lin (Lin+1)
  END_WHILE

END_DEFINE


DEFINE KE_calc_update_text_get_info
  LOCAL Lin
  LOCAL Rounding
  LOCAL Value
  
  KE_lib_str_left_of Text_info ':'
  KE_lib_str_right_of Text_info ':'
  IF (KE_lib_str_left_of_r = 'KE_CALC_NAME')
    SELECT_FROM_LTAB KE_calc_tab_name COLUMN KE_calc_col_name = KE_lib_str_right_of_r END
    LET Lin ( READ_LTAB 'sys_select' 1 1 )
    LET Rounding ( VAL ( READ_LTAB KE_calc_tab_name Lin KE_calc_col_round ))
    LET Value ( ROUND_DIG VAL ( READ_LTAB KE_calc_tab_name Lin KE_calc_col_value ) Rounding )
    CHANGE_TEXT ( STR Value ) GLOBAL TEXTS ( INQ 101 ) END
  END_IF
END_DEFINE


DEFINE KE_calc_write_file
  LOCAL Lin
  LOCAL Nb_row
  LOCAL Var

  LET Nb_row ( LTAB_ROWS KE_calc_tab_name )
  OPEN_OUTFILE 1 DEL_OLD KE_calc_file
  WRITE_FILE 1 'DEFINE KE_calc_macro'
  
  LET Lin 1
  WHILE (Lin <= Nb_row)
    WRITE_FILE 1 ('LOCAL ' + ( READ_LTAB KE_calc_tab_name Lin KE_calc_col_name ) )
    LET Lin (Lin+1)
  END_WHILE
  
  LET Lin 1
  WHILE (Lin <= Nb_row)
    LET Var ( READ_LTAB KE_calc_tab_name Lin KE_calc_col_name )
    WRITE_FILE 1 ('LET ' + Var + ' ( ' + READ_LTAB KE_calc_tab_name Lin KE_calc_col_formula + ' )')
    WRITE_FILE 1 ('WRITE_LTAB KE_calc_tab_name ' + STR Lin +' KE_calc_col_value ( STR ' + Var + ' )')
    LET Lin (Lin+1)
  END_WHILE
  
  WRITE_FILE 1 'END_DEFINE'
  WRITE_FILE 1 'KE_calc_macro'
  WRITE_FILE 1 'KE_calc_update_text'
  CLOSE_FILE 1
END_DEFINE

{ geo_9_1.m }
{ ====================================================================== }


DEFINE KE_cse_load
  LOAD KE_cse_file_out_tmp
END_DEFINE


DEFINE KE_cse_start
  LOCAL Size
  LOCAL Tmp
  
  READ NUMBER PROMPT ( DGETTEXT 'KE' "Enter the size (lines and arcs with length and circles with diameter below size will be removed)" ) Size
  STORE MI ALL DEL_OLD KE_cse_file_in_tmp
  RUN NO_WINDOW MESSAGE ( DGETTEXT 'KE' "Cleaning small elements started ...")
   (KE_install_dir+'\cse '+KE_cse_file_in_tmp+' '+KE_cse_file_out_tmp+' '+KE_cse_file_log_tmp+' '+ STR Size)
  LET Tmp ( WINEXEC ('"'+KE_cse_file_log_tmp+'"') )

END_DEFINE


{ Search for Unconnected Elements, ie with at least one vertex not common with another element. }
{ Cherche des éléments non connectés, c'est-à-dire avec au moins un vertex non commun avec un autre élément. }
LET KE_uce_tab_name 'uce'

DEFINE KE_uce_search
  LOCAL Ctr
  LOCAL Nb_elt

  CREATE_LTAB 200 2 KE_uce_tab_name
  INQ_SELECTED_ELEM SELECT LINES ALL OR ARCS ALL OR FILLETS ALL CONFIRM
  LET Nb_elt ( INQ 14 )
  LET Ctr 1
  WHILE (Ctr <= Nb_elt)
    WRITE_LTAB KE_uce_tab_name Ctr 1 ( INQ 332 )
    IF (( INQ 403 ) = LINE )
      WRITE_LTAB KE_uce_tab_name Ctr 2 ( STR ( INQ 101 ))
    ELSE
      WRITE_LTAB KE_uce_tab_name Ctr 2 ( STR ( INQ 103 ))
    END_IF
    WRITE_LTAB KE_uce_tab_name (Nb_elt + Ctr) 1 ( INQ 332 )
    WRITE_LTAB KE_uce_tab_name (Nb_elt + Ctr) 2 ( STR ( INQ 102 ))
    INQ_NEXT_ELEM
    LET Ctr (Ctr+1)
  END_WHILE

  LET Nb_elt ( LTAB_ROWS KE_uce_tab_name )
  LET Ctr 1
  WHILE (Ctr <= Nb_elt)
    SELECT_FROM_LTAB KE_uce_tab_name COLUMN 2 = ( READ_LTAB KE_uce_tab_name Ctr 2 ) END
    IF (( LTAB_ROWS 'sys_select') < 2 )
      SHOW SELECT POINTER ( READ_LTAB KE_uce_tab_name Ctr 1 ) CONFIRM RED
    END_IF
    LET Ctr (Ctr+1)
  END_WHILE

END_DEFINE



{ dim_10_0.m }

DEFINE KE_dim_std_load
  LOCAL Lin
  
  IF (KE_dim_std_enable)
    KE_lib_file_exists KE_dir_home KE_dim_std_file_save
    IF (KE_lib_file_exists_r = KE_n_yes)
      OPEN_INFILE 1 (KE_dir_home + '\' + KE_dim_std_file_save)
      READ_FILE 1 Lin
      CLOSE_FILE 1
      IF (Lin = '1')
        Dim_standard_ansi
      ELSE_IF (Lin = '2')
        Dim_standard_iso
      ELSE_IF (Lin = '3')
        Dim_standard_din
      ELSE_IF (Lin = '4')
        Dim_standard_jis
      ELSE_IF (Lin = '5')
        Dim_standard_company
      END_IF
    END_IF
  END_IF
END_DEFINE


DEFINE KE_dim_std_mod_file
  LOCAL File_original
  LOCAL Lin
  
  LET File_original ( GETENV 'MEDIR' + '\da_std.m' )
  OPEN_INFILE 1 File_original
  OPEN_OUTFILE 2 DEL_OLD KE_dim_std_file_mod
  
  LOOP
    READ_FILE 1 Lin
  EXIT_IF (Lin = 'END-OF-FILE')
    WRITE_FILE 2 Lin
    IF ( POS Lin 'Dam_std_flag' )
      WRITE_FILE 2 'KE_dim_std_save'
    END_IF
  END_LOOP
  
  CLOSE_FILE 1
  CLOSE_FILE 2
  INPUT KE_dim_std_file_mod
END_DEFINE


DEFINE KE_dim_std_save
  OPEN_OUTFILE 1 DEL_OLD (KE_dir_home + '\' + KE_dim_std_file_save)
  WRITE_FILE 1 Dam_std_flag
  CLOSE_FILE 1
END_DEFINE

KE_dim_std_mod_file
KE_dim_std_load

{ txt_9_1.m }
{ ====================================================================== }


DEFINE KE_txt_center_box
  LOCAL P0
  LOCAL P1
  LOCAL P2
  LOCAL P3
  LOCAL Pt

  LOOP
    READ PNT PROMPT ( DGETTEXT 'KE' "Identify the text to place in the center of the box" ) Pt
    INQ_SELECTED_ELEM TEXTS Pt
    IF ( ( INQ 403 ) = TEXT )
      LET P0 ( INQ 101 )
      READ PNT PROMPT ( DGETTEXT 'KE' "Indicate the first corner of the box" ) RUBBER_LINE Pt P1
      READ PNT PROMPT ( DGETTEXT 'KE' "Indicate the second corner of the box" ) RUBBER_BOX P1 P2
      CHANGE_TEXT_ADJUST 5 P0
      LET P3 ((P1+P2)/2)
      MODIFY MOVE P0 P3 P0
    END_IF
  END_LOOP
END_DEFINE


DEFINE KE_txt_csv_to_txt
  LOCAL Col
  LOCAL Ltab_line
  LOCAL Ltab_name
  LOCAL Nb_line
  LOCAL P00

  LET Ltab_name 'KE_txt_csv_to_txt'
  CREATE_LTAB 100 100 Ltab_name

  READ NUMBER PROMPT ( DGETTEXT 'KE' "Enter the interval between the lines" ) DEFAULT KE_txt_csv_to_txt_int_lin KE_txt_csv_to_txt_int_lin
  READ NUMBER PROMPT ( DGETTEXT 'KE' "Enter the interval between the columns" ) DEFAULT KE_txt_csv_to_txt_int_col KE_txt_csv_to_txt_int_col
  KE_lib_file_csv_to_ltab '' Ltab_name
  LET Nb_line ( LTAB_ROWS Ltab_name )
  LET Nb_col ( LTAB_COLUMNS Ltab_name )
  READ PNT PROMPT ( DGETTEXT 'KE' "Indicate the insertion point of the table" ) P00

  LET Ltab_line 1
  WHILE (Ltab_line <= Nb_line)
  LET Col 1
    WHILE (Col <= Nb_col)
      TEXT ( STR ( READ_LTAB Ltab_name Ltab_line Col )) (P00 - (Ltab_line-1)*KE_txt_csv_to_txt_int_lin*(0,1) + (Col-1)*KE_txt_csv_to_txt_int_col*(1,0))
      LET Col (Col+1)
    END_WHILE
    LET Ltab_line (Ltab_line+1)
  END_WHILE
  END


END_DEFINE


DEFINE KE_txt_on_line
  LOCAL Adj
  LOCAL Lin_ang
  LOCAL P0
  LOCAL P1
  LOCAL P2
  LOCAL P3
  LOCAL Pt

  LOOP
    READ PNT NUMBER PROMPT (( DGETTEXT 'KE' "Identify the text to place on a line or enter offset - current is " ) + STR KE_txt_on_line_offset) Pt
    IF ( TYPE Pt = PNT )
      INQ_SELECTED_ELEM TEXTS Pt
      IF ( ( INQ 403 ) = TEXT )
        LET P0 ( INQ 101 )
        LET Adj ( INQ 3 )
        IF ( ( Adj = 4 ) OR ( Adj = 7 ) ) LET Adj 1 END_IF
        IF ( ( Adj = 5 ) OR ( Adj = 8 ) ) LET Adj 2 END_IF
        IF ( ( Adj = 6 ) OR ( Adj = 9 ) ) LET Adj 3 END_IF
        READ PNT PROMPT ( DGETTEXT 'KE' "Identify the line" ) RUBBER_LINE P0 Pl
        INQ_SELECTED_ELEM LINES Pl
        IF ( ( INQ 403 ) = LINE )
          LET P1 ( INQ 101 ) 
          LET P2 ( INQ 102 )
          LET Lin_ang ( ANG (P2 - P1) )
          IF ( Lin_ang > 90  ) LET Lin_ang ( Lin_ang - 180 ) END_IF
          IF ( Lin_ang <= -90 ) LET Lin_ang ( Lin_ang + 180 ) END_IF
          CHANGE_TEXT_ADJUST Adj Pt
          CHANGE_TEXT_ANGLE Lin_ang P0
          LET P3 ( PNT_XY
            ( X_OF Pl - ( SIN (Lin_ang) ) * KE_txt_on_line_offset )
            ( Y_OF Pl + ( COS (Lin_ang) ) * KE_txt_on_line_offset ))
          IF ( LEN (P0 - P3) > 0.01 )
            MODIFY MOVE P0 P3 TEXTS P0
          END_IF
        END_IF
      END_IF
    ELSE
      LET KE_txt_on_line_offset Pt
    END_IF
  END_LOOP
END_DEFINE


DEFINE KE_txt_replace
  LOCAL Ctr
  LOCAL Inq_902
  LOCAL Inq_903
  LOCAL Nb_elt
  LOCAL New_str
  LOCAL New_txt
  LOCAL Old_str
  LOCAL Old_txt
  LOCAL Replace
  LOCAL Str_pos

  LOOP
    READ STRING PROMPT ( DGETTEXT 'KE' "Enter 'text' to replace" ) Old_str
    READ STRING PROMPT ( DGETTEXT 'KE' "Enter new 'text'" ) New_str
    INQ_SELECTED_ELEM TEXTS ALL
    LET Nb_elt ( INQ 14 )
    LET Ctr 1
    SPOTLIGHT ON
    SHOW ALL RGB_COLOR KE_txt_colour_shade
    WHILE (Ctr<=Nb_elt)
      LET Replace 0
      CHANGE_TEXT
      LET Old_txt ( INQ 902 )
      KE_txt_replace_substr
      LOOP
        LET Old_txt ( INQ 903 )
      EXIT_IF (Old_txt = 'END-OF-LIST')
        KE_txt_replace_substr
      END_LOOP
      IF (Replace)
          ( INQ 101 )
        SHOW ( INQ 101 ) RGB_COLOR KE_txt_colour_highlight
      END_IF      
      INQ_NEXT_ELEM
      LET Ctr (Ctr+1)
    END_WHILE
  END_LOOP

END_DEFINE


DEFINE  KE_txt_replace_substr
  LET Str_pos ( POS Old_txt Old_str )
  IF (Str_pos)  {3}
    LET Replace 1
    LET New_txt ( SUBSTR Old_txt 1 (Str_pos - 1))
    LET New_txt (New_txt + New_str)
    LET New_txt (New_txt + ( SUBSTR Old_txt ( Str_pos + ( LEN Old_str)) ( LEN Old_txt)))
    New_txt
  ELSE
    IF (Old_txt <> '') Old_txt END_IF
  END_IF
END_DEFINE


DEFINE KE_txt_search
  LOCAL String
  LOCAL Ctr
  LOCAL Inq_903
  LOCAL Nb_elt

  LOOP
    READ STRING PROMPT ( DGETTEXT 'KE' "Enter 'text' to search" ) String
    INQ_SELECTED_ELEM GLOBAL TEXTS ALL
    LET Nb_elt ( INQ 14 )
    LET Ctr 1
    SPOTLIGHT OFF
    SHOW GLOBAL ALL RGB_COLOR KE_txt_colour_shade
    WHILE (Ctr<=Nb_elt)
      IF ( POS ( INQ 902 ) String)
        SHOW GLOBAL ( INQ 101 ) RGB_COLOR KE_txt_colour_highlight
      ELSE
        LOOP
          LET Inq_903 ( INQ 903 )
        EXIT_IF (Inq_903 = 'END-OF-LIST')
          IF ( POS Inq_903 String)
            SHOW GLOBAL ( INQ 101) RGB_COLOR KE_txt_colour_highlight
          END_IF
        END_LOOP
      END_IF
      INQ_NEXT_ELEM
      LET Ctr (Ctr+1)
    END_WHILE
  END_LOOP
END_DEFINE


DEFINE KE_txt_txt_to_csv
  LOCAL Col
  LOCAL Ctr
  LOCAL File_csv
  LOCAL Lin
  LOCAL Nb_line
  LOCAL Nb_text
  LOCAL P1
  LOCAL P2
  LOCAL Ltab_name_csv
  LOCAL Ltab_name_me10
  LOCAL X
  LOCAL X1
  LOCAL Y
  LOCAL Y1

  LET KE_txt_txt_to_csv_rounding 1
  LET File_csv (KE_dir_temp+'\KE_txt_txt_to_csv.csv')
  LET Ltab_name_csv 'KE_txt_txt_to_csv_csv'
  LET Ltab_name_me10 'KE_txt_txt_to_csv_me10'

  LOOP
    READ PNT NUMBER PROMPT (( DGETTEXT 'KE' "Indicate the first point of the box containing the texts or enter rounding - current is " ) + STR KE_txt_txt_to_csv_rounding) P1
  EXIT_IF ( TYPE P1 = PNT )
    LET KE_txt_txt_to_csv_rounding P1
  END_LOOP
  
  READ PNT PROMPT ( DGETTEXT 'KE' "Indicate the second point of the box containing the texts" ) RUBBER_BOX P1 P2
  INQ_SELECTED_ELEM TEXTS P1 P2
  LET Nb_text ( INQ 14 )
  CREATE_LTAB Nb_text 3 Ltab_name_me10
  CREATE_LTAB 100 100 Ltab_name_csv

  LET Ctr 1
  WHILE (Ctr <= Nb_text)
    LET P1 (( ROUND (( INQ 101 )/KE_txt_txt_to_csv_rounding) ) * KE_txt_txt_to_csv_rounding)
    WRITE_LTAB Ltab_name_me10 Ctr 1 ( INQ 902 )
    WRITE_LTAB Ltab_name_me10 Ctr 2 ( Y_OF P1 )
    WRITE_LTAB Ltab_name_me10 Ctr 3 ( X_OF P1 )
    INQ_NEXT_ELEM
    LET Ctr (Ctr+1)
  END_WHILE

  LET Nb_line ( LTAB_ROWS Ltab_name_me10 )

  { Convert the ordinates in line numbers. }
  { Convertit les ordonnées en numéro de ligne. }
  SORT_LTAB Ltab_name_me10 REVERSE_SORT 2 CONFIRM
  LET Lin 1
  LET Y1 ( READ_LTAB Ltab_name_me10 1 2 )
  WRITE_LTAB Ltab_name_me10 1 2 1
  LET Ctr 2
  WHILE (Ctr <= Nb_line)
    LET Y ( READ_LTAB Ltab_name_me10 Ctr 2 )
    IF (Y <> Y1)
      LET Y1 Y
      LET Lin (Lin+1)
    END_IF
    WRITE_LTAB Ltab_name_me10 Ctr 2 Lin
    LET Ctr (Ctr+1)      
  END_WHILE

  { Convert the abscisses in column numbers. }
  { Convertit les abscisses en numéro de ligne. }
  SORT_LTAB Ltab_name_me10 3 CONFIRM
  LET Col 1
  LET X1 ( READ_LTAB Ltab_name_me10 1 3 )
  WRITE_LTAB Ltab_name_me10 1 3 1
  LET Ctr 2
  WHILE (Ctr <= Nb_line)
    LET X ( READ_LTAB Ltab_name_me10 Ctr 3 )
    IF (X <> X1)
      LET X1 X
      LET Col (Col+1)
    END_IF
    WRITE_LTAB Ltab_name_me10 Ctr 3 Col
    LET Ctr (Ctr+1)      
  END_WHILE

  SORT_LTAB Ltab_name_me10 2 3 CONFIRM

  { Write the csv file. }
  { Ecrit le fichier csv. }
  LET Ctr 1
  WHILE (Ctr <= Nb_line)
    WRITE_LTAB Ltab_name_csv ( READ_LTAB Ltab_name_me10 Ctr 2 ) ( READ_LTAB Ltab_name_me10 Ctr 3 ) ( READ_LTAB Ltab_name_me10 Ctr 1 )
    LET Ctr (Ctr+1)      
  END_WHILE

  KE_lib_file_ltab_to_csv Ltab_name_csv File_csv
  LET Tmp ( WINEXEC ('"'+File_csv+'"') )

END_DEFINE

{ 6_tlb_menu_web_9_1.m }
{ ====================================================================== }


DEFINE KE_tlb_calc
  LOCAL Ctr

  LET Ctr 1
  TOOLBAR DEL_OLD 'tlb_KE_calc' CAPTION 'Kotom-Eng Calc' END
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_calc_set_name' CAPTION ( DGETTEXT 'KE' "Set Name" ) TOOLTIP ( DGETTEXT 'KE' "Set Name of a variable" ) ON_ACTION 'KE_calc_set_name' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_calc_set_formula' CAPTION ( DGETTEXT 'KE' "Set formula" ) TOOLTIP ( DGETTEXT 'KE' "Set formula" ) ON_ACTION 'KE_calc_set_formula' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_calc_set_rounding' CAPTION ( DGETTEXT 'KE' "Set rounding" ) TOOLTIP ( DGETTEXT 'KE' "Set the number of decimal places" ) ON_ACTION 'KE_calc_set_rounding' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'Separator' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_calc_clear_name' CAPTION ( DGETTEXT 'KE' "Clear" ) TOOLTIP ( DGETTEXT 'KE' "Clear Name and formula" ) ON_ACTION 'KE_calc_clear_name' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'Separator' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_calc_do_calc' CAPTION ( DGETTEXT 'KE' "Calculate" ) TOOLTIP ( DGETTEXT 'KE' "Do the calculation" ) ON_ACTION 'KE_calc_do_calc' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'Separator' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_calc_show' CAPTION ( DGETTEXT 'KE' "Show" ) TOOLTIP ( DGETTEXT 'KE' "Show variables" ) ON_ACTION 'KE_calc_show' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_calc_show_reset' CAPTION ( DGETTEXT 'KE' "Reset colours" ) TOOLTIP ( DGETTEXT 'KE' "Reset colours" ) ON_ACTION ' SHOW GLOBAL ALL ON SPOTLIGHT ON ' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'Separator' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_calc_show_table' CAPTION ( DGETTEXT 'KE' "Table" ) TOOLTIP ( DGETTEXT 'KE' "Show table" ) ON_ACTION ' SHOW_TABLE ON KE_calc_tab_name' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
  TOOLBAR 'tlb_KE_calc' FLOAT 600 250 1 END

END_DEFINE


DEFINE KE_tlb_cse
  LOCAL Ctr

  LET Ctr 1
  TOOLBAR DEL_OLD 'tlb_KE_cse' CAPTION 'Kotom-Eng cse' END
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_cse_start' CAPTION ( DGETTEXT 'KE' "Start" ) TOOLTIP ( DGETTEXT 'KE' "Start (a new file is created, the drawing on screen remains unmodified)" ) ON_ACTION 'KE_cse_start' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_cse_load' CAPTION ( DGETTEXT 'KE' "Load" ) TOOLTIP ( DGETTEXT 'KE' "Load the cleaned drawing" ) ON_ACTION 'KE_cse_load' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
  TOOLBAR 'tlb_KE_cse' FLOAT 600 250 1 END

END_DEFINE


DEFINE KE_tlb_main
  LOCAL Ctr

  LET Ctr 1
  TOOLBAR DEL_OLD 'tlb_KE_main' CAPTION 'Kotom-Eng Tools' END
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_tlb_calc' CAPTION 'Calc' TOOLTIP ( DGETTEXT 'KE' 'Calculation') ON_ACTION 'KE_tlb_calc' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_tlb_cse' CAPTION 'CSE' TOOLTIP ( DGETTEXT 'KE' "Clean small elements" ) ON_ACTION 'KE_tlb_cse' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'Separator' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_txt_center_box' CAPTION ( DGETTEXT 'KE' "Txt Center Box" ) TOOLTIP ( DGETTEXT 'KE' "Move a text in the center of a box" ) ON_ACTION 'KE_txt_center_box' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_txt_on_line' CAPTION ( DGETTEXT 'KE' "Txt on Line" ) TOOLTIP ( DGETTEXT 'KE' "Move a text on a line" ) ON_ACTION 'KE_txt_on_line' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'Separator' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_txt_csv_to_txt' CAPTION 'csv -> txt' TOOLTIP ( DGETTEXT 'KE' "Write a table from a csv file" ) ON_ACTION 'KE_txt_csv_to_txt' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_txt_txt_to_csv' CAPTION 'txt -> csv' TOOLTIP ( DGETTEXT 'KE' "Write a csv file from a table" ) ON_ACTION 'KE_txt_txt_to_csv' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'Separator' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_txt_search' CAPTION ( DGETTEXT 'KE' "Txt Search" ) TOOLTIP ( DGETTEXT 'KE' "Search text" ) ON_ACTION 'KE_txt_search' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_txt_replace' CAPTION ( DGETTEXT 'KE' "Txt Replace" ) TOOLTIP ( DGETTEXT 'KE' "Replace text" ) ON_ACTION 'KE_txt_replace' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_txt_search_normal' CAPTION ( DGETTEXT 'KE' "Normal" ) TOOLTIP ( DGETTEXT 'KE' "Show normal colours" ) ON_ACTION ' SHOW GLOBAL ALL ON ' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'Separator' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_uce_search' CAPTION ( DGETTEXT 'KE' "Unconn. Elts" ) TOOLTIP ( DGETTEXT 'KE' "Search for Unconnected Elements" ) ON_ACTION 'KE_uce_search' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_uce_search_normal' CAPTION ( DGETTEXT 'KE' "Normal" ) TOOLTIP ( DGETTEXT 'KE' "Show normal colours" ) ON_ACTION ' SHOW GLOBAL ALL ON ' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'Separator' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
    TOOLBAR_ITEM OVER_WRITE 'btn_KE_web_site' CAPTION ( DGETTEXT 'KE' "Web site" ) TOOLTIP ( DGETTEXT 'KE' "Web site" ) ON_ACTION 'KE_web_site' ADD_TO_TOOLBAR Ctr END LET Ctr (Ctr+1)
  TOOLBAR 'tlb_KE_main' FLOAT 500 200 1 END

END_DEFINE


DEFINE KE_web_site
  LOCAL Tmp
  
  LET Tmp ( WINEXEC ('"http://kotom.eng.free.fr"') )
END_DEFINE


DEFINE Sm_ke_tools
  LET Lastmen 'Tm_ke_tools'
  IF (I_port)
    Check_i_port
  END_IF
  IF ( NOT I_port )
    MENU_BUFFER ON
    CURRENT_MENU Sm_ke_tools_layout_name T_clear_menu Menu_control_icons
    MENU Colo0 Bcol5 CENTER 'Kotom-Eng Tools' '' 1 3
    
    MENU Colo0 Bcol1 ( DGETTEXT 'KE' 'CALCULATION') '' 3 1
    MENU ( DGETTEXT 'KEm' "Set Name" ) 'KE_calc_set_name' 4 1
    MENU ( DGETTEXT 'KEm' "Set formula" ) 'KE_calc_set_formula' 4 2
    MENU ( DGETTEXT 'KEm' "Set rounding" ) 'KE_calc_set_rounding' 5 1
    MENU Colo0 Bcol1 ( DGETTEXT 'KE' "Clear" ) 'KE_calc_clear_name' 6 1
    MENU Colo0 Bcol1 ( DGETTEXT 'KE' "Calculate" ) 'KE_calc_do_calc' 6 2
    MENU ( DGETTEXT 'KE' "Show" ) 'KE_calc_show' 7 1
    MENU ( DGETTEXT 'KE' "Normal" ) ' SHOW GLOBAL ALL ON SPOTLIGHT ON ' 7 2
    MENU ( DGETTEXT 'KE' "Table" ) ' SHOW_TABLE ON KE_calc_tab_name' 8 1

    MENU Colo0 Bcol1 'cse' '' 10 1
    MENU Colo0 Bcol1 ( DGETTEXT 'KE' "Start" ) 'KE_cse_start' 11 1
    MENU Colo0 Bcol1 ( DGETTEXT 'KE' "Load" ) 'KE_cse_load' 11 2

    MENU Colo0 Bcol1 ( DGETTEXT 'KEm' "Txt Center Box" ) 'KE_txt_center_box' 13 1
    MENU Colo0 Bcol1 ( DGETTEXT 'KEm' "Txt on Line" ) 'KE_txt_on_line' 13 2

    MENU Colo0 Bcol1 'csv -> txt' 'KE_txt_csv_to_txt' 15 1
    MENU Colo0 Bcol1 'txt -> csv' 'KE_txt_txt_to_csv' 15 2

    MENU Colo0 Bcol1 ( DGETTEXT 'KEm' "Txt Search" ) 'KE_txt_search' 17 1
    MENU Colo0 Bcol1 ( DGETTEXT 'KEm' "Txt Replace" ) 'KE_txt_replace' 17 2
    MENU Colo0 Bcol1 ( DGETTEXT 'KE' "Normal" ) ' SHOW GLOBAL ALL ON ' 18 1

    MENU Colo0 Bcol1 ( DGETTEXT 'KEm' "Unconn Elt" ) 'KE_uce_search' 20 1
    MENU Colo0 Bcol1 ( DGETTEXT 'KE' "Normal" ) ' SHOW GLOBAL ALL ON ' 20 2

    MENU Colo0 Bcol1 ( DGETTEXT 'KE' "Web site" ) 'KE_web_site' 22 1
    
  END_IF
END_DEFINE


DEFINE Sm_ke_tools_layout
  CURRENT_MENU 'Sm_ke_tools'
  CURRENT_SCREEN 1
  MENU_LAYOUT Menu_position RIGHT Layout_body_1 Menu_home_point_top
  MENU_STATUS ENABLE_INQ
  LET Sm_ke_tools_layout_name 'Sm_ke_tools'
END_DEFINE


DEFINE Sm_ke_tools_layout_name
  Sm_ke_tools_layout
END_DEFINE


DEFINE Tm_ke_tools
  Sm_ke_tools
END_DEFINE


